<?php
/* --------------------------------------------------------------
   dependent.inc.php 2017-10-25
   Gambio GmbH
   http://www.gambio.de
   Copyright © 2017 Gambio GmbH
   Released under the GNU General Public License (Version 2)
   [http://www.gnu.org/licenses/gpl-2.0.html]
   --------------------------------------------------------------
*/

/**
 * Check if gm_configuration value SHOW_PRODUCTS_COUNT is present, if not add it
 */
$check = $this->query('SELECT * FROM `gm_configuration` WHERE `gm_key` = "SHOW_PRODUCTS_COUNT"', true);
if($check->num_rows === 0)
{
	$query     = 'INSERT INTO `gm_configuration`
				SET `gm_key` = "SHOW_PRODUCTS_COUNT",
					`gm_value` = "false"';
	$t_success &= $this->query($query, true);
}

/**
 * ATTACH_PRIVACY_NOTICE_IN_ORDER_CONFIRMATION
 */
$check = $this->query('SELECT * FROM `gm_configuration` WHERE `gm_key` = "ATTACH_PRIVACY_NOTICE_IN_ORDER_CONFIRMATION"',
                      true);
if($check->num_rows === 0)
{
	$query     = 'INSERT INTO `gm_configuration`
				SET `gm_key` = "ATTACH_PRIVACY_NOTICE_IN_ORDER_CONFIRMATION",
					`gm_value` = "1"';
	$t_success &= $this->query($query, true);
}

/**
 * Add customer_id column to orders_status_history table
 */
$t_check = $this->table_column_exists('orders_status_history', 'customer_id');
if(!$t_check)
{
	$query     = 'ALTER TABLE `orders_status_history` ADD `customer_id` INT(5) NOT NULL DEFAULT 0';
	$t_success &= $this->query($query, true);
}

# Add URL to REST actions list to gambio_hub module
$check = $this->query('SELECT * FROM `configuration` WHERE `configuration_key` = "MODULE_PAYMENT_GAMBIO_HUB_REST_ACTIONS_URL"',
                      true);
if($check->num_rows === 0)
{
	$query     = 'INSERT INTO `configuration`
                SET `configuration_key` = "MODULE_PAYMENT_GAMBIO_HUB_REST_ACTIONS_URL",
                    `configuration_value` = "https://core-api.gambiohub.com/api/trust/rest_actions.json",
                    `configuration_group_id` = 6,
                    `sort_order` = 0,
                    `use_function` = "",
                    `set_function` = ""';
	$t_success &= $this->query($query, true);
}

# Add On/Off-Switch for REST-API actions access
$check = $this->query('SELECT * FROM `gm_configuration` WHERE `gm_key` = "GAMBIO_HUB_ALLOW_REST_ACTIONS"', true);
if($check->num_rows === 0)
{
	$query     = 'INSERT INTO `gm_configuration`
                SET `gm_key` = "GAMBIO_HUB_ALLOW_REST_ACTIONS",
                    `gm_value` = "false"';
	$t_success &= $this->query($query, true);
}

/**
 * Add URLS for configurable hub text phrases
 */
$check = $this->query('SELECT * FROM `gm_configuration` WHERE `gm_key`="GAMBIO_HUB_PHRASES_URL"', true);
if($check->num_rows === 0)
{
	$query     = "INSERT INTO `gm_configuration` SET `gm_key`='GAMBIO_HUB_PHRASES_URL', `gm_value`='https://core-api.gambiohub.com/api/trust/hub_phrases.json'";
	$t_success &= $this->query($query, true);
}

/**
 * Add "check stock before shopping cart" config option
 */
$check = $this->query('SELECT `configuration_id` FROM `configuration` WHERE `configuration_key` = "CHECK_STOCK_BEFORE_SHOPPING_CART"',
                      true);
if($check->num_rows === 0)
{
	$query     = "INSERT INTO `configuration` SET `configuration_key` = 'CHECK_STOCK_BEFORE_SHOPPING_CART', `configuration_value` = 'false', `configuration_group_id` = 9, `sort_order` = 8, `use_function` = NULL, `set_function` = 'gm_cfg_select_option(array(''true'', ''false''),', `date_added` = NOW();";
	$t_success &= $this->query($query, true);
}
$t_check = $this->table_column_exists('content_manager', 'content_type');
if(!$t_check)
{
	$query     = 'ALTER TABLE `content_manager` ADD COLUMN `content_type` VARCHAR(64) NOT NULL AFTER `contents_meta_keywords`';
	$t_success &= $this->query($query, true);
}

$t_check = $this->table_column_exists('content_manager', 'content_position');
if(!$t_check)
{
	$query     = 'ALTER TABLE `content_manager` ADD COLUMN `content_position` VARCHAR(64) NOT NULL AFTER `contents_meta_keywords`';
	$t_success &= $this->query($query, true);
}

/**
 * Create of new content manager product content db scheme for the import of old product contents.
 */

$t_check = $this->table_exists('product_content_customer_status');
if(!$t_check)
{
	$query     = '
		CREATE TABLE IF NOT EXISTS `product_content_customer_status` (
	`product_content_id` INT NOT NULL,
	`customer_status_id` INT NOT NULL,
	PRIMARY KEY (`product_content_id` ASC, `customer_status_id` ASC)
)
	ENGINE = InnoDB;
	';
	$t_success &= $this->query($query, true);
}

$t_check = $this->table_exists('product_content_descriptions');
if(!$t_check)
{
	$query     = '
		CREATE TABLE IF NOT EXISTS `product_content_descriptions` (
	`id`                 INT         NOT NULL AUTO_INCREMENT,
	`product_content_id` INT         NOT NULL,
	`language_id`        INT         NOT NULL,
	`title`              VARCHAR(64) NULL,
	`content`            TEXT        NULL,
	`hits`               INT         NOT NULL         DEFAULT 0,
	PRIMARY KEY (`id`),
	UNIQUE INDEX `product_content_id_language_id` (`product_content_id`, `language_id`)
)
	ENGINE = InnoDB;
	';
	$t_success &= $this->query($query, true);
}

$t_check = $this->table_exists('product_content_products');
if(!$t_check)
{
	$query     = '
		CREATE TABLE IF NOT EXISTS `product_content_products` (
	`product_content_id` INT NOT NULL,
	`product_id`         INT NOT NULL,
	PRIMARY KEY (`product_id` ASC, `product_content_id` ASC)
)
	ENGINE = InnoDB;
	';
	$t_success &= $this->query($query, true);
}

$t_check = $this->table_exists('product_content_resources');
if(!$t_check)
{
	$query     = '
		CREATE TABLE IF NOT EXISTS `product_content_resources` (
	`product_content_description_id` INT          NOT NULL,
	`product_content_types_id`       INT          NOT NULL,
	`resource`                       VARCHAR(255) NULL,
	PRIMARY KEY (`product_content_description_id`, `product_content_types_id`)
)
	ENGINE = InnoDB;
	';
	$t_success &= $this->query($query, true);
}

$t_check = $this->table_exists('product_content_types');
if(!$t_check)
{
	$query     = '
		CREATE TABLE IF NOT EXISTS `product_content_types` (
	`id`   INT         NOT NULL AUTO_INCREMENT,
	`name` VARCHAR(64) NULL,
	PRIMARY KEY (`id`)
)
	ENGINE = InnoDB;
	';
	$t_success &= $this->query($query, true);
}

$check = $this->query('SELECT * FROM `product_content_types` WHERE `name` = "file"', true);
if($check->num_rows === 0)
{
	$query     = 'INSERT INTO `product_content_types` (`name`) VALUE ("file")';
	$t_success &= $this->query($query, true);
}

$check = $this->query('SELECT * FROM `product_content_types` WHERE `name` = "link"', true);
if($check->num_rows === 0)
{
	$query     = 'INSERT INTO `product_content_types` (`name`) VALUE ("link")';
	$t_success &= $this->query($query, true);
}

$t_check = $this->table_exists('product_contents');
if(!$t_check)
{
	$query     = '
		CREATE TABLE IF NOT EXISTS `product_contents` (
	`id`   INT         NOT NULL         AUTO_INCREMENT,
	`name` VARCHAR(64) NOT NULL,
	PRIMARY KEY (`id`)
)
	ENGINE = InnoDB;
	';
	$t_success &= $this->query($query, true);
}

// Add URL to REST actions list to gambio_hub module
$check = $this->query('SELECT * FROM `configuration` WHERE `configuration_key` = "MODULE_PAYMENT_GAMBIO_HUB_REST_ACTIONS_URL"',
                      true);
if($check->num_rows === 0)
{
	$query     = "INSERT INTO `configuration` SET `configuration_key` = 'MODULE_PAYMENT_GAMBIO_HUB_REST_ACTIONS_URL', `configuration_value` = 'https://core-api.gambiohub.com/trust/rest_actions.json', `configuration_group_id` = 6, `sort_order` = 0, `use_function` = '', `set_function` = ''";
	$t_success &= $this->query($query, true);
}

// Add On/Off-Switch for REST-API actions access
$check = $this->query('SELECT * FROM `gm_configuration` WHERE `gm_key` = "GAMBIO_HUB_ALLOW_REST_ACTIONS"', true);
if($check->num_rows === 0)
{
	$conf_value = '0';

	$check = $this->query('SELECT * FROM `gm_configuration` WHERE `gm_key` = "GAMBIO_HUB_CLIENT_KEY" AND `gm_value` != ""',
	                      true);
	if($check->num_rows === 1)
	{
		$conf_value = '1';
	}

	$query     = "INSERT INTO `gm_configuration` SET `gm_key` = 'GAMBIO_HUB_ALLOW_REST_ACTIONS', `gm_value` = '"
	             . $conf_value . "'";
	$t_success &= $this->query($query, true);
}

/**
 * Import of old product contents.
 */

// get existing file contents first
$results   = $this->query('SELECT * FROM `products_content`');
$languages = $this->query('SELECT `languages_id` FROM `languages`');

$errorCount = count($this->get_sql_errors());
$error      = false;

$t_check = count($this->query('SELECT * FROM `product_contents`;')) === 0;
if($t_check)
{
	foreach($results as $result)
	{
		$productContentsQuery = 'INSERT INTO `product_contents` (`name`) VALUE ("' . $result['content_name'] . '")';

		$this->query($productContentsQuery, true);
		// Abort import on error
		$error = (count($this->get_sql_errors()) > $errorCount) ? true : false;
		if($error)
		{
			break;
		}
		// run after insertion
		$productContentId = $this->get_insert_id();

		$productContentProductsQuery = 'INSERT INTO `product_content_products` (`product_content_id`, `product_id`) VALUES ("'
		                               . $productContentId . '", "' . $result['products_id'] . '")';
		$this->query($productContentProductsQuery, true);
		// Abort import on error
		$error = (count($this->get_sql_errors()) > $errorCount) ? true : false;
		if($error)
		{
			break;
		}

		$productContentDescriptionQuery = 'INSERT INTO `product_content_descriptions` (`product_content_id`, `language_id`, `title`, `content`) VALUES ("'
		                                  . $productContentId . '", "' . $result['languages_id'] . '", "'
		                                  . $result['content_name'] . '", "'
		                                  . $this->real_escape_string($result['file_comment']) . '");';

		$this->query($productContentDescriptionQuery, true);
		// Abort import on error
		$error = (count($this->get_sql_errors()) > $errorCount) ? true : false;
		if($error)
		{
			break;
		}

		// run after insertion
		$productContentDescriptionId = $this->get_insert_id();

		$productContentTypeId         = $result['content_file'] !== '' ? 1 : 2;
		$productContentResource       = $result['content_file']
		                                !== '' ? $result['content_file'] : $result['content_link'];
		$productContentResourcesQuery = 'INSERT INTO `product_content_resources` (`product_content_description_id`, `product_content_types_id`, `resource`) VALUES ("'
		                                . $productContentDescriptionId . '", "' . $productContentTypeId . '", "'
		                                . $productContentResource . '")';

		$this->query($productContentResourcesQuery, true);
		// Abort import on error
		$error = (count($this->get_sql_errors()) > $errorCount) ? true : false;
		if($error)
		{
			break;
		}

		// add empty entries for other existing languages
		foreach($languages as $language)
		{
			if($language['languages_id'] !== $result['languages_id'])
			{
				$productContentDescriptionQuery = 'INSERT INTO `product_content_descriptions` (`product_content_id`, `language_id`, `title`, `content`) VALUES ("'
				                                  . $productContentId . '", "' . $language['languages_id']
				                                  . '", "", "");';

				$this->query($productContentDescriptionQuery, true);
				// Abort import on error
				$error = (count($this->get_sql_errors()) > $errorCount) ? true : false;
				if($error)
				{
					break;
				}

				$productContentDescriptionId = $this->get_insert_id();

				$productContentResourcesQuery = 'INSERT INTO `product_content_resources` (`product_content_description_id`, `product_content_types_id`, `resource`) VALUES ("'
				                                . $productContentDescriptionId . '", "' . $productContentTypeId
				                                . '", "")';

				$this->query($productContentResourcesQuery, true);
				// Abort import on error
				$error = (count($this->get_sql_errors()) > $errorCount) ? true : false;
				if($error)
				{
					break;
				}
			}
		}
	}

	// If an error happened while the import, then truncate the tables.
	if($error)
	{
		$this->query('TRUNCATE `product_contents`;');
		$this->query('TRUNCATE `product_content_descriptions`;');
		$this->query('TRUNCATE `product_content_resources`;');
		$this->query('TRUNCATE `product_content_products`;');
		$this->query('TRUNCATE `product_content_customer_status`;');
	}

	$t_success &= !$error;
}

$contentManagerResults = $this->query('SELECT * FROM `content_manager`');
$pagesInfoBoxIds       = array(
	'8'
);
$pagesInfoIds          = array(
	'2',
	'3',
	'4',
	'6',
	'7',
	'14',
	'3889891',
	'3889895',
	'3889896',
	'3889897',
	'3889898',
	'3889899'
);
$pagesMainIds          = array(
	'30',
	'82'
);
$elementStartIds       = array(
	'5',
	'10',
	'11',
	'4321002',
	'4321003',
	'4321004'
);
$elementsHeaderIds     = array(
	'4321001'
);
$elementsFooterIds     = array(
	'199',
	'4321005',
	'4321006',
	'4321007'
);
$elementsBoxIds        = array(
	'61',
	'62',
	'63',
	'64',
	'65',
	'66',
	'67',
	'68',
	'69'
);
$elementsOthers        = array(
	'198',
	'3210123'
);

foreach($contentManagerResults as $contentManagerResult)
{
	if(in_array((string)$contentManagerResult['content_group'], $pagesInfoIds))
	{
		$contentPosition = 'pages_info';
	}
	elseif(in_array((string)$contentManagerResult['content_group'], $pagesMainIds))
	{
		$contentPosition = 'pages_main';
	}
	elseif(in_array((string)$contentManagerResult['content_group'], $pagesInfoBoxIds))
	{
		$contentPosition = 'pages_info_box';
	}
	elseif(in_array((string)$contentManagerResult['content_group'], $elementStartIds))
	{
		$contentPosition = 'elements_start';
	}
	elseif(in_array((string)$contentManagerResult['content_group'], $elementsHeaderIds))
	{
		$contentPosition = 'elements_header';
	}
	elseif(in_array((string)$contentManagerResult['content_group'], $elementsFooterIds))
	{
		$contentPosition = 'elements_footer';
	}
	elseif(in_array((string)$contentManagerResult['content_group'], $elementsBoxIds))
	{
		$contentPosition = 'elements_boxes';
	}
	elseif(in_array((string)$contentManagerResult['content_group'], $elementsOthers))
	{
		$contentPosition = 'elements_others';
	}
	else
	{
		$contentPosition = 'pages_info';
	}

	// first checks if content position do not start with "elements_" (content type "link" does not exists for elements)
	// Content type is link, if both, gm_link and content_file entry exists, or gm_link only.
	// Content type is file if content_file entry exists only.
	// In all other cases, the content_type is content
	if($contentManagerResult['gm_link'] !== '' && !strpos($contentPosition, 'elements_') === 0)
	{
		$contentType = 'link';
	}
	elseif($contentManagerResult['content_file'] !== '')
	{
		$contentType = 'file';
	}
	else
	{
		$contentType = 'content';
	}

	$query     = 'UPDATE `content_manager` SET `content_position` = "' . $contentPosition . '", `content_type` = "'
	             . $contentType . '" WHERE `content_id` = "' . $contentManagerResult['content_id'] . '"';
	$t_success &= $this->query($query, true);
}

/**
 * Transferring content manager table URL keywords entries to the URL rewrite table.
 */

// Content manager entries with URL keywords.
$contentManagerEntriesWithUrlKeywords = $this->query('SELECT content_group, languages_id, gm_url_keywords FROM content_manager WHERE gm_url_keywords <> ""');

// URL rewrite entries.
$urlRewriteEntries = $this->query("SELECT content_id, language_id, rewrite_url FROM url_rewrites WHERE rewrite_url <> ''");

// Iterate over each content manager entry.
if(count($contentManagerEntriesWithUrlKeywords))
{
	foreach($contentManagerEntriesWithUrlKeywords as $entry)
	{
		// Content ID.
		$contentGroupId = $entry['content_group'];

		// URL keywords.
		$urlKeywords = $entry['gm_url_keywords'];

		// Language ID.
		$languageId = $entry['languages_id'];

		// Is there an entry in the URL rewrites table for that content ID?
		$isUrlRewriteEntryFound = false;

		// Iterate over each URL rewrite entry and find the according content ID.
		foreach($urlRewriteEntries as $urlRewriteEntry)
		{
			// Content ID.
			$urlRewriteContentId = $urlRewriteEntry['content_id'];

			// Check whether the content IDs coincide.
			if($urlRewriteContentId === $contentGroupId)
			{
				$isUrlRewriteEntryFound = true;
				break;
			}
		}

		// Create a new entry in the URL rewrite table, if no entry is found.
		if(!$isUrlRewriteEntryFound)
		{
			$insertUrlRewriteEntryQuery = "REPLACE INTO url_rewrites VALUES ('${contentGroupId}', 'content', '${languageId}', '${urlKeywords}', 'shop_content.php?coID=${contentGroupId}')";
			$t_success                  &= (boolean)$this->query($insertUrlRewriteEntryQuery, true);
		}
	}
}

/**
 * Switching EyeCandy to Honeygrid and create a backup entry for this option in the gm_configuration.
 */

// Old template name.
$oldTemplate = 'EyeCandy';

// New template name.
$newTemplate = 'Honeygrid';

// Get current template data.
$getCurrentTemplateDataQuery = $this->query('
  SELECT *
  FROM `configuration`
  WHERE `configuration_key` = "CURRENT_TEMPLATE";
');

// Current template name.
$currentTemplate = $getCurrentTemplateDataQuery[0]['configuration_value'];

// If the current set template is not Honeygrid then switch to it.
if ($currentTemplate === $oldTemplate) {
    // Save current template as backup template configuration value.
    $t_success &= $this->query('
      REPLACE INTO `gm_configuration` (`gm_key`, `gm_value`)
      VALUES ("CURRENT_TEMPLATE_BACKUP", "' . $currentTemplate . '");
    ', true);

    // Set current template configuration value to Honeygrid.
    $t_success &= $this->query('
      UPDATE `configuration`
      SET `configuration_value` = "' . $newTemplate . '"
      WHERE `configuration_key` = "CURRENT_TEMPLATE";
    ', true);

    // Deactivate mobile candy.
    $t_success &= $this->query('
      UPDATE `gm_configuration`
      SET `gm_value` = "false"
      WHERE `gm_key` = "MOBILE_TEMPLATE_ACTIVE";
    ', true);
}


/**
 * Activate the responsive file manager.
 */

// Check queries.
$responsiveFileManagerActivationCheckQuery = $this->query('SELECT * FROM `gm_configuration` WHERE `gm_key` = "MODULE_CENTER_RESPONSIVEFILEMANAGER_INSTALLED";');
$responsiveFileManagerConfigurationValuesCheckQuery = $this->query('SELECT * FROM `configuration_storage` WHERE `key` LIKE "modules/admin/responsivefilemanager/%";');

// Activate the responsive file manager.
if (!count($responsiveFileManagerActivationCheckQuery)) {
    $activateResponsiveFileManagerQuery = 'INSERT INTO `gm_configuration` (`gm_key`, `gm_value`) VALUES ("MODULE_CENTER_RESPONSIVEFILEMANAGER_INSTALLED", "1");';
    $t_success &= $this->query($activateResponsiveFileManagerQuery, true);
}

// Insert the responsive file manager configuration values.
if (!count($responsiveFileManagerConfigurationValuesCheckQuery)) {
    $configureResponsiveFileManagerQuery = '
      INSERT INTO `configuration_storage` (`key`, `value`) VALUES
          ("modules/admin/responsivefilemanager/use_in_attribute_pages", "1"),
          ("modules/admin/responsivefilemanager/use_in_banner_manager_pages", "1"),
          ("modules/admin/responsivefilemanager/use_in_ckeditor", "1"),
          ("modules/admin/responsivefilemanager/use_in_content_manager_pages", "1"),
          ("modules/admin/responsivefilemanager/use_in_manufacturer_pages", "1"),
          ("modules/admin/responsivefilemanager/use_in_product_and_category_pages", "1"),
          ("modules/admin/responsivefilemanager/use_in_shipping_status_pages", "1");
    ';
    $t_success &= $this->query($configureResponsiveFileManagerQuery, true);
}