<?php
/* --------------------------------------------------------------
   dependent.inc.php 2018-01-30
   Gambio GmbH
   http://www.gambio.de
   Copyright © 2018 Gambio GmbH
   Released under the GNU General Public License (Version 2)
   [http://www.gnu.org/licenses/gpl-2.0.html]
   --------------------------------------------------------------
*/

/**
 * Add new column "content_name" to table "content_manager"
 */
$t_check = $this->table_column_exists('content_manager', 'content_name');
if (!$t_check) {
    $t_query   = "ALTER TABLE `content_manager` ADD `content_name` text NOT NULL";
    $t_success &= $this->query($t_query, true);
    
    // Fill new column with a default value
    $t_query   = "UPDATE `content_manager` SET `content_name` = `content_title`";
    $t_success &= $this->query($t_query, true);
}

/**
 * Delete the old Luxembourg districts.
 */
$query     = "DELETE FROM `zones` WHERE (`zone_code` = 'D' OR `zone_code` = 'G' OR `zone_code` = 'L')  AND
                ( `zone_name` = 'Grevenmacher' OR `zone_name` = 'Diekirch' OR `zone_name` = 'Luxembourg (fr)' ) ";
$t_success &= $this->query($query, true);

/**
 * Add the new Luxembourg Cantons if not exist.
 */
$zonesNames = array(
    'Capellen'            => 'CA',
    'Clerf'               => 'CL',
    'Diekirch'            => 'DI',
    'Echternach'          => 'EC',
    'Esch an der Alzette' => 'ES',
    'Grevenmacher'        => 'GR',
    'Luxemburg'           => 'LU',
    'Mersch'              => 'ME',
    'Redingen'            => 'RD',
    'Remich'              => 'RM',
    'Vianden'             => 'VD',
    'Wiltz'               => 'WI'
);

$t_check = $this->query('SELECT * FROM `zones` WHERE `zone_country_id` = 124 ', true);

$databaseZone = array();

while ($row = $t_check->fetch_assoc()) {
    $databaseZone[$row['zone_name']] = $row['zone_code'];
}

$result = array_diff_assoc($zonesNames, $databaseZone);

if (!empty($result)) {
    
    foreach ($result as $zoneName => $zoneCode) {
        $query     = "INSERT INTO `zones` (`zone_country_id`, `zone_code`, `zone_name`) VALUE('124', '$zoneCode', '$zoneName')";
        $t_success &= $this->query($query, true);
    }
}
/**
 * Check if gm_configuration value SHOW_ABANDONMENT_OF_WITHDRAWL_DOWNLOAD is present, if not add it
 */
$check = $this->query('SELECT * FROM `gm_configuration` WHERE `gm_key` = "SHOW_ABANDONMENT_OF_WITHDRAWL_DOWNLOAD"', true);
if($check->num_rows === 0)
{
	$query     = 'INSERT INTO `gm_configuration`
				SET `gm_key` = "SHOW_ABANDONMENT_OF_WITHDRAWL_DOWNLOAD",
					`gm_value` = "1"';
	$t_success &= $this->query($query, true);
}

/**
 * Check if gm_configuration value SHOW_ABANDONMENT_OF_WITHDRAWL_SERVICE is present, if not add it
 */
$check = $this->query('SELECT * FROM `gm_configuration` WHERE `gm_key` = "SHOW_ABANDONMENT_OF_WITHDRAWL_SERVICE"', true);
if($check->num_rows === 0)
{
	$query     = 'INSERT INTO `gm_configuration`
				SET `gm_key` = "SHOW_ABANDONMENT_OF_WITHDRAWL_SERVICE",
					`gm_value` = "1"';
	$t_success &= $this->query($query, true);
}

/**
 * Check if gm_configuration value CHECK_ABANDONMENT_OF_WITHDRAWL_DOWNLOAD is present, if not add it
 */
$check = $this->query('SELECT * FROM `gm_configuration` WHERE `gm_key` = "CHECK_ABANDONMENT_OF_WITHDRAWL_DOWNLOAD"', true);
if($check->num_rows === 0)
{
	$query     = 'INSERT INTO `gm_configuration`
				SET `gm_key` = "CHECK_ABANDONMENT_OF_WITHDRAWL_DOWNLOAD",
					`gm_value` = "0"';
	$t_success &= $this->query($query, true);
}

/**
 * Check if gm_configuration value CHECK_ABANDONMENT_OF_WITHDRAWL_SERVICE is present, if not add it
 */
$check = $this->query('SELECT * FROM `gm_configuration` WHERE `gm_key` = "CHECK_ABANDONMENT_OF_WITHDRAWL_SERVICE"', true);
if($check->num_rows === 0)
{
	$query     = 'INSERT INTO `gm_configuration`
				SET `gm_key` = "CHECK_ABANDONMENT_OF_WITHDRAWL_SERVICE",
					`gm_value` = "0"';
	$t_success &= $this->query($query, true);
}

/**
 * Update footer copyright year
 */
$row = $this->query("SELECT `gm_value` FROM `gm_configuration` WHERE `gm_key` = 'GM_FOOTER'");
if(!empty($row))
{
	$oldValue = $row[0]['gm_value'];
	$newValue = preg_replace('/20[\d]{2}/', '2018', $oldValue);
	$t_query  = "UPDATE `gm_configuration` 
					SET `gm_value` = '" . $this->coo_mysqli->real_escape_string($newValue) . "' 
					WHERE `gm_key` = 'GM_FOOTER'";
	$t_success &= is_numeric($this->query($t_query));
}

$check = $this->query("SELECT `gm_value`, `languages_id` FROM `gm_contents` WHERE `gm_key` = 'GM_FOOTER'");
foreach($check as $row)
{
	$oldValue = $row['gm_value'];
	$newValue = preg_replace('/20[\d]{2}/', '2018', $oldValue);
	$t_query  = "UPDATE `gm_contents` 
					SET `gm_value` = '" . $this->coo_mysqli->real_escape_string($newValue) . "' 
					WHERE `gm_key` = 'GM_FOOTER' AND `languages_id` = " . $row['languages_id'];
	$t_success &= is_numeric($this->query($t_query));
}

/**
 * Database update for google services
 */
// Add export_type for google shopping
$check = $this->query('SELECT * FROM `export_types` WHERE `type_id` = 3 AND `language_id` = 1', true);

if($check->num_rows === 0)
{
    $query = 'INSERT INTO `export_types`
					SET `name` = "Google Shopping",
						`language_id` = 1,
						`type_id` = 3';
    $t_success &= $this->query($query, true);
}

$check = $this->query('SELECT * FROM `export_types` WHERE `type_id` = 3 AND `language_id` = 2', true);
if($check->num_rows === 0)
{
    $query = 'INSERT INTO `export_types`
					SET `name` = "Google Shopping",
						`language_id` = 2,
						`type_id` = 3';
    $t_success &= $this->query($query, true);
}

if(!$this->table_column_exists('export_scheme_fields', 'status'))
{
    $query = 'ALTER TABLE `export_scheme_fields` ADD `status` tinyint(1) NOT NULL DEFAULT 1';
    $t_success &= $this->query($query, true);
}

// Add Google Adwords Connection Status
$check = $this->query('SELECT * FROM `gm_configuration` WHERE `gm_key`= "GOOGLE_ADWORDS_CONNECTION_STATUS"', true);
if($check->num_rows === 0)
{
    $query = 'INSERT INTO `gm_configuration` (gm_key, gm_value) VALUES ("GOOGLE_ADWORDS_CONNECTION_STATUS", "false")';
    $t_success &= $this->query($query, true);
}

// Add Google Adwords refresh token
$check = $this->query('SELECT * FROM `gm_configuration` WHERE `gm_key`= "GOOGLE_ADWORDS_REFRESH_TOKEN"', true);
if($check->num_rows === 0)
{
    $query = 'INSERT INTO `gm_configuration` (gm_key) VALUES ("GOOGLE_ADWORDS_REFRESH_TOKEN")';
    $t_success &= $this->query($query, true);
}

// Add Google Adwords Campaigns Overview API Url
$check = $this->query('SELECT * FROM `gm_configuration` WHERE `gm_key`= "GOOGLE_ADWORDS_API_URL"',
    true);
if($check->num_rows === 0)
{
    $query = 'INSERT INTO `gm_configuration` (gm_key, gm_value) VALUES ("GOOGLE_ADWORDS_API_URL", "https://stage-googleservices.gambio.com/a/index.php/api/v1")';
    $t_success &= $this->query($query, true);
}

$check = $this->query('SELECT * FROM `gm_configuration` WHERE `gm_key`= "GOOGLE_ADWORDS_APP_URL"',
    true);
if($check->num_rows === 0)
{
    $query = 'INSERT INTO `gm_configuration` (gm_key, gm_value) VALUES ("GOOGLE_ADWORDS_APP_URL", "https://stage-googleservices.gambio.com/index.html")';
    $t_success &= $this->query($query, true);
}

// Add table for Google AdWords client customer ids
if(!$this->table_exists('google_adwords_client_customers'))
{
    $query = '
		CREATE TABLE `google_adwords_client_customers` (
		  `client_customer_id` varchar(12) NOT NULL,
		  `primary` int(1) NOT NULL DEFAULT \'0\',
		  PRIMARY KEY (`client_customer_id`)
		) ENGINE=InnoDB DEFAULT CHARSET=utf8 ;
	';
    $t_success &= $this->query($query, true);
}

// Add UPDATE_DOWNLOADER_URL to gm_configuration
$check = $this->query('SELECT * FROM `gm_configuration` WHERE `gm_key` = "UPDATE_DOWNLOADER_URL";');
if($check->num_rows === 0)
{
	$query     = 'INSERT INTO `gm_configuration`
					SET `gm_key` = "UPDATE_DOWNLOADER_URL",
						`gm_value` = "https://updates.gambio-support.de/v1/check.php"';
	$t_success &= $this->query($query, true);
}

// Remove HUB_CONNECTOR_UPDATER_URL from gm_configuration
$check = $this->query('SELECT * FROM `gm_configuration` WHERE `gm_key` = "HUB_CONNECTOR_UPDATER_URL";');
if($check->num_rows !== 0)
{
	$query     = 'DELETE FROM `gm_configuration` WHERE `gm_key` = "HUB_CONNECTOR_UPDATER_URL";';
	$t_success &= $this->query($query, true);
}